<?php

/*
 * LMS version 1.11.13 Dira
 *
 *  (C) Copyright 2001-2011 LMS Developers
 *
 *  Please, see the doc/AUTHORS for more information about authors!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 *
 *  $Id: promotionadd.php,v 1.1 2011/03/02 10:31:05 alec Exp $
 */

$promotion = isset($_POST['promotion']) ? $_POST['promotion'] : NULL;

if ($promotion)
{
	foreach ($promotion as $key => $value)
		$promotion[$key] = trim($value);

	if ($promotion['name']=='' && $promotion['description']=='')
	{
		$SESSION->redirect('?m=promotionlist');
	}

	if ($promotion['name'] == '')
		$error['name'] = trans('Promotion name is required!');
	else if ($DB->GetOne('SELECT id FROM promotions WHERE name = ?', array($promotion['name'])))
		$error['name'] = trans('Specified name is in use!');

	if (!$error)
	{
        $DB->Execute('INSERT INTO promotions (name, description)
            VALUES (?, ?)',
            array($promotion['name'], $promotion['description']));

		if (empty($promotion['reuse']))
		{
            $pid = $DB->GetLastInsertId('promotions');

			$SESSION->redirect('?m=promotioninfo&id='.$pid);
		}

		unset($promotion);
		$promotion['reuse'] = '1';
	}
}

$layout['pagetitle'] = trans('New Promotion');

$SMARTY->assign('error', $error);
$SMARTY->assign('promotion', $promotion);
$SMARTY->display('promotionadd.html');

?>
